# Define the kmod package name here.
%define kmod_name mlink

# If kversion isn't defined on the rpmbuild line, define it here.
%{!?kversion: %define kversion 2.6.32-220.7.1.el6}

%{!?kvariants: %define kvariants ""}

Name:    %{kmod_name}-kmod
Version: 1.32
Release: 1.%{svn_rev}%{?dist}
Group:   System Environment/Kernel
License: GPLv2
Summary: %{kmod_name} kernel module(s)
URL:     http://www.centos.org/

BuildRequires: redhat-rpm-config
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-build-%(%{__id_u} -n)
ExclusiveArch: i686 x86_64

# Sources.
Source0:  %{kmod_name}-%{version}.tar.bz2
Source10: kmodtool-%{kmod_name}-el5.sh

# Define the variants for each architecture.
%define basevar ""
%ifarch i686
%define paevar PAE
%endif
%ifarch i686 x86_64
%define xenvar xen
%endif

# If kvariants isn't defined on the rpmbuild line, build all variants for this architecture.
%{!?kvariants: %define kvariants %{?basevar} %{?xenvar} %{?paevar}}

# Magic hidden here.
%{expand:%(sh %{SOURCE10} rpmtemplate %{kmod_name} %{kversion}.%{_target_cpu} %{kvariants})}

# Disable the building of the debug package(s).
%define debug_package %{nil}

# Define the filter.
%define __find_requires sh %{_builddir}/%{buildsubdir}/filter-requires.sh

%description
This package provides the CentOS-5 bug-fixed %{kmod_name} kernel module (bug #1776).
It is built to depend upon the specific ABI provided by a range of releases
of the same variant of the Linux kernel and not on any one specific build.

%prep
%setup -q -c -T -a 0
for kvariant in %{kvariants} ; do
    %{__cp} -a %{kmod_name}-%{version} _kmod_build_$kvariant
done
echo "/usr/lib/rpm/redhat/find-requires | %{__sed} -e '/^ksym.*/d'" > filter-requires.sh
#echo "override %{kmod_name} * weak-updates/%{kmod_name}" > kmod-%{kmod_name}.conf

%build
for kvariant in %{kvariants} ; do
    KSRC=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}.%{_target_cpu}
    %{__make} -C "${KSRC}" %{?_smp_mflags} modules M=$PWD/_kmod_build_$kvariant
done

%install
%{__rm} -rf %{buildroot}
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=extra/%{kmod_name}
for kvariant in %{kvariants} ; do
    KSRC=%{_usrsrc}/kernels/%{kversion}${kvariant:+-$kvariant}.%{_target_cpu}
    %{__make} -C "${KSRC}" modules_install M=$PWD/_kmod_build_$kvariant
done
#%{__install} -d %{buildroot}%{_sysconfdir}/depmod.d/
#%{__install} kmod-%{kmod_name}.conf %{buildroot}%{_sysconfdir}/depmod.d/
# Set the module(s) to be executable, so that they will be stripped when packaged.
find %{buildroot} -type f -name \*.ko -exec %{__chmod} u+x \{\} \;

%clean
%{__rm} -rf %{buildroot}

%changelog
* Wed Apr 25 2012  <Ilja.Slepnev@jinr.ru> - 
- EL6 Support

* Wed May 13 2009  <Ilja.Slepnev@jinr.ru> - 
- Fixed package name

* Tue May 12 2009  <Ilja.Slepnev@jinr.ru> - 
- Split in two packages: mlink and mlink-kmod

* Wed Apr 22 2009  <Ilja.Slepnev@jinr.ru> - 
- 1.30: build with kmodtool2. Package name changed: mlink-utils, mlink-kmod

* Mon Apr 20 2009  <Ilja.Slepnev@jinr.ru> - 
- removed mlink.ko file. use melink.ko

* Wed Apr 08 2009  <Ilja.Slepnev@jinr.ru> - 
- 1.29: Removed special run-mode. Packet mode only.

* Tue Mar 25 2009  <Ilja.Slepnev@jinr.ru> - 
- Fixed communication problem caused by receiver_reset() in RXC handler
- testlink: Fixed clock locking problem when changing loopback mode

* Tue Mar  3 2009  <Ilja.Slepnev@jinr.ru> - 
- Changed version to 1.28
- Added MlinkDevice interface class

* Thu Feb 12 2009  <Ilja.Slepnev@jinr.ru> - 
- Added control frame loopback bit

* Thu Dec 11 2008  <Ilja.Slepnev@jinr.ru> - 
- Handle link up/down status on reset, use OSD bit

* Thu Nov 28 2008  <Ilja.Slepnev@jinr.ru> - 
- defined 'kdir' macro
- fixed x86_64 warnings

* Thu Nov 27 2008  <Ilja.Slepnev@jinr.ru> - 
- spec file corrected to build on Fedora 10.

* Tue Nov 18 2008  <Ilja.Slepnev@jinr.ru> - 
- Initial build.

